ExtJS(6)- 用Sencha Cmd构建打包Ext项目

用ExtJS组建前端框架有一年多了,考虑到ExtJS中js过多,为提高效率,所以开始寻找打包的方法,然后就发现了这个Sencha Cmd。首先Sencha Cmd不仅仅是为了打包而生的,它同样具有构建前端框架的作用。

    以下为所需的环境:

Sencha Cmd 下载地址:http://www.sencha.com/products/sencha-cmd/download/
Ruby 下载地址:http://rubyinstaller.org/downloads

Ant下载地址:http://ant.apache.org/bindownload.cgi

 

Ruby是为了使用其中的gem(类似于nodejs中的NPM)去下载sass和compass,而compass在build中起到编译打包sass文件为css文件的作用。

Ruby安装完成后会有gem一起安装完成,由于国内的网络,用gem加载sass与compass时要注意替换gem的resources地址,参照淘宝提供的镜像

 

1、创建workspace:

sencha generate workspace /path/to/workspace

2、创建项目

sencha generate app -ext MyApp /path/to/MyApp

3、build项目

此处sencha命令需要到MyApp目录下执行

sencha app build

4、sencha运行

sencha web start

登陆地址:

http://localhost:1841/MyApp/

 

其中build中多次遇到 MyApp\.sencha\app\build-impl.xml中报错

一下提出一种解决方案:

1、在ext\cmd下的sencha.cfg起始处添加配置skip.sass=1

2、将ext\cmd下的sencha.cfg文件拷贝到MyApp\app目录下

3、到MyApp目录下sencha app build打包

4、将build\temp\production\MyApp\slicer-temp下的MyApp-example.css拷贝到build\production\MyApp\resources下,并更名为MyApp-all.css

5、重新执行步骤3

出错步骤还是存在于sass文件的编译打包过程中,此处将本应该生成到目标地址的文件用文件替换的方式让build继续走下去。

如果大家有相应的解决方案,请不吝赐教!

 

更换主题样式

修改./app.js的一下内容:

"theme": "ext-theme-crisp",

修改bootstrap.css

@import '../ext/packages/ext-theme-crisp/build/resources/ext-theme-crisp-all.css';

修改完成后重新编译

 

添加图表插件

如果要调用ext-charts:(此处解决方案借鉴stackoverflow)

1、重新编译ext-charts,这一点很关键,也是解决ext5中legend异常的方案(问题可参照我的另一篇chart博客

cp -R ext/packages/ext-charts ./packages/ext-charts
cd ./packages/ext-charts
sencha package build

2、./app.json中添加配置

"requires": [
    "ext-charts"
],

然后

sencha app refresh

或者重新编译app

sencha app build

重新编译时一定要把bootstrap.css修改回编译前的样式css

@import '../ext/packages/ext-theme-crisp/build/resources/ext-theme-crisp-all-rtl.css';

编译后的样子是

@import '../build/production/MyApp2/resources/MyApp-all.css';

若以此形式重新编译就会出现legend显示异常等问题

 

打包测试模式

打包后的测试模式可以进行调试,代码未压缩混淆,但文件已合并为production形式

sencha app build testing

testing打包后位置为 build\testing\MyApp

 

chart的production版本图表异常

引用ext-charts后在workspace中调试正常,

但是build时没有报错,且build production后图表显示异常,报错仅是

.js not found

然后我们需要采用testing模式来调试就能看到真正的报错,发现是缺少 'axis.numeric','axis.category','series.column'等引用,在打包后的app.js中也找不到这些js。

那我们要在哪里添加这些模块呢,我们需要在具体引用这些模块的地方

requires:[
        "Ext.chart.series.Column",
        "Ext.chart.axis.Numeric",
        "Ext.chart.axis.Category"
    ],

这个问题要感谢这篇stack overflow提供的思路。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值